/* Sistemas Integrados TECNISA

Nome: LOG_RECEITABRUTA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   02/01/2012 - Kessiler Almeida S. Rodrigues
*/

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_RECEITABRUTA' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_RECEITABRUTA
GO
CREATE TRIGGER LOG_RECEITABRUTA
ON RECEITABRUTA
FOR UPDATE,INSERT, DELETE
AS
  DECLARE @V_NMUSUARIO           VARCHAR(40);
  DECLARE @V_IDTIPOOPER          VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_IDCOMANDO           VARCHAR(1);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  

  DECLARE @V_CDEMPRESA_NEW       VARCHAR(4);
  DECLARE @V_DTREFRECEITABR_NEW  DATETIME;
  DECLARE @V_IDSTATUSMES_NEW     VARCHAR(1);
  DECLARE @V_VRRECEITABR_NEW     DOUBLE PRECISION;
  DECLARE @V_VRSALDONEGMES_NEW   DOUBLE PRECISION;
  DECLARE @V_VRSALDOCOMPOE_NEW   DOUBLE PRECISION;
  DECLARE @V_VRSALDODEDUZ_NEW    DOUBLE PRECISION;
  DECLARE @V_CDEMPRESA_OLD       VARCHAR(4);
  DECLARE @V_DTREFRECEITABR_OLD  DATETIME;
  DECLARE @V_IDSTATUSMES_OLD     VARCHAR(1);
  DECLARE @V_VRRECEITABR_OLD     DOUBLE PRECISION;
  DECLARE @V_VRSALDONEGMES_OLD   DOUBLE PRECISION;
  DECLARE @V_VRSALDOCOMPOE_OLD   DOUBLE PRECISION;
  DECLARE @V_VRSALDODEDUZ_OLD    DOUBLE PRECISION;
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC         = '';
   SET @V_ITPESQ       = '';
   SET @V_NMUSUARIO   = '';
   SET @V_IDTIPOOPER   = '0';


   DECLARE C_CURSOR_REC CURSOR FOR
      SELECT
         'D' IDCOMANDO,
	      NULL,
	      NULL,
	      NULL,
	      NULL,
         NULL,
         NULL,
         NULL,
         CDEMPRESA,
	      DTREFRECEITABR,
	      IDSTATUSMES,
	      VRRECEITABR,
         VRSALDONEGMES,
         VRSALDOCOMPOE,
         VRSALDODEDUZ
       FROM DELETED
      WHERE 0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDEMPRESA,
	      INSERTED.DTREFRECEITABR,
         INSERTED.IDSTATUSMES,
	      INSERTED.VRRECEITABR,
         INSERTED.VRSALDONEGMES,
         INSERTED.VRSALDOCOMPOE,
         INSERTED.VRSALDODEDUZ,
         DELETED.CDEMPRESA,
	      DELETED.DTREFRECEITABR,
	      DELETED.IDSTATUSMES,
	      DELETED.VRRECEITABR,
         DELETED.VRSALDONEGMES,
         DELETED.VRSALDOCOMPOE,
         DELETED.VRSALDODEDUZ
      FROM
         INSERTED, DELETED
      WHERE
         INSERTED.CDEMPRESA    = DELETED.CDEMPRESA

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         CDEMPRESA,
	      DTREFRECEITABR,
	      IDSTATUSMES,
	      VRRECEITABR,
         VRSALDONEGMES,
         VRSALDOCOMPOE,
         VRSALDODEDUZ,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
       FROM
         INSERTED
      WHERE 0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_REC;
   FETCH NEXT FROM C_CURSOR_REC   INTO  @V_IDCOMANDO,   @V_CDEMPRESA_NEW, @V_DTREFRECEITABR_NEW,
                                        @V_IDSTATUSMES_NEW, @V_VRRECEITABR_NEW, @V_VRSALDONEGMES_NEW, @V_VRSALDOCOMPOE_NEW,
                                        @V_VRSALDODEDUZ_NEW,@V_CDEMPRESA_OLD,  @V_DTREFRECEITABR_OLD, @V_IDSTATUSMES_OLD,
                                        @V_VRRECEITABR_OLD, @V_VRSALDONEGMES_OLD, @V_VRSALDOCOMPOE_OLD,
                                        @V_VRSALDODEDUZ_OLD;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_IDCOMANDO = 'D' BEGIN
         IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Empresa=' + @V_CDEMPRESA_OLD;
         END;
         IF @V_DTREFRECEITABR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DataReferencia=' + CONVERT(VARCHAR, @V_DTREFRECEITABR_OLD, 103);
         END;
         IF @V_IDSTATUSMES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Status=' + @V_IDSTATUSMES_OLD;
         END;
         IF @V_VRRECEITABR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Valor=' + CONVERT(VARCHAR, @V_VRRECEITABR_OLD);
         END;
         IF @V_VRSALDONEGMES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SaldoNeg=' + CONVERT(VARCHAR, @V_VRSALDONEGMES_OLD);
         END;
         IF @V_VRSALDOCOMPOE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SaldoCompoe=' + CONVERT(VARCHAR, @V_VRSALDOCOMPOE_OLD);
         END;
         IF @V_VRSALDODEDUZ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SaldoDeduz=' + CONVERT(VARCHAR, @V_VRSALDODEDUZ_OLD);
         END;
         SET @V_ITPESQ        = @V_CDEMPRESA_OLD+CONVERT(VARCHAR, @V_DTREFRECEITABR_OLD, 103);
         SET @V_IDTIPOOPER    = '3';
      END
      ELSE BEGIN
         IF @V_IDCOMANDO = 'U' BEGIN
            IF  ISNULL(@V_CDEMPRESA_NEW, '!') <> ISNULL(@V_CDEMPRESA_OLD, '!') OR
                ISNULL(@V_DTREFRECEITABR_NEW, GETDATE()) <> ISNULL(@V_DTREFRECEITABR_OLD, GETDATE()) OR
                ISNULL(@V_IDSTATUSMES_NEW, '!') <> ISNULL(@V_IDSTATUSMES_OLD, '!') OR
                ISNULL(@V_VRRECEITABR_NEW, -1) <> ISNULL(@V_VRRECEITABR_OLD, -1)   OR
                ISNULL(@V_VRSALDONEGMES_OLD, -1) <> ISNULL(@V_VRSALDONEGMES_NEW, -1) OR
                ISNULL(@V_VRSALDOCOMPOE_OLD, -1) <> ISNULL(@V_VRSALDOCOMPOE_NEW, -1) OR
                ISNULL(@V_VRSALDODEDUZ_OLD, -1) <> ISNULL(@V_VRSALDODEDUZ_NEW, -1)  BEGIN
               SET @V_ITPESQ     = @V_CDEMPRESA_OLD+CONVERT(VARCHAR, @V_DTREFRECEITABR_OLD, 103);
               SET @V_IDTIPOOPER = '2';
            END;
         END
         ELSE BEGIN
            SET @V_ITPESQ     = @V_CDEMPRESA_NEW+CONVERT(VARCHAR, @V_DTREFRECEITABR_NEW, 103);
            SET @V_IDTIPOOPER = '1';
         END;
         IF ISNULL(@V_CDEMPRESA_NEW, '!') <> ISNULL(@V_CDEMPRESA_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Empresa=' + @V_CDEMPRESA_NEW;
         END;
         IF ISNULL(@V_DTREFRECEITABR_NEW, GETDATE()) <> ISNULL(@V_DTREFRECEITABR_OLD, GETDATE()) BEGIN
            SET @V_DESC = @V_DESC + ' DataReferencia=' + CONVERT(VARCHAR, @V_DTREFRECEITABR_NEW, 103);
         END;
         IF ISNULL(@V_IDSTATUSMES_NEW, '!') <> ISNULL(@V_IDSTATUSMES_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Status=' + @V_IDSTATUSMES_NEW;
         END;
         IF ISNULL(@V_VRRECEITABR_NEW, -1) <> ISNULL(@V_VRRECEITABR_OLD, -1) BEGIN
            SET @V_DESC = @V_DESC + ' Valor=' + CONVERT(VARCHAR, @V_VRRECEITABR_NEW);
         END;
         IF ISNULL(@V_VRSALDONEGMES_OLD, -1) <> ISNULL(@V_VRSALDONEGMES_NEW, -1) BEGIN
            SET @V_DESC = @V_DESC + ' SaldoNeg=' + CONVERT(VARCHAR, @V_VRSALDONEGMES_NEW);
         END;
         IF ISNULL(@V_VRSALDOCOMPOE_OLD, -1) <> ISNULL(@V_VRSALDOCOMPOE_NEW, -1) BEGIN
            SET @V_DESC = @V_DESC + ' SaldoCompoe=' + CONVERT(VARCHAR, @V_VRSALDOCOMPOE_NEW);
         END;
         IF ISNULL(@V_VRSALDODEDUZ_OLD, -1) <> ISNULL(@V_VRSALDODEDUZ_NEW, -1) BEGIN
            SET @V_DESC = @V_DESC + ' SaldoDeduz=' + CONVERT(VARCHAR, @V_VRSALDODEDUZ_NEW);
         END;
      END;
      IF NOT @V_DESC IS NULL AND @V_IDTIPOOPER <> '0' BEGIN
         EXEC NMUSUARIO  @P_NMUSUARIO    = @V_NMUSUARIO OUTPUT;
         EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                         @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                         @P_DSSERVERRDM  = @V_DSSERVERRDM  OUTPUT,
                         @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                         @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;
         SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('RECEITABRUTA',
             GETDATE(),
             ISNULL(@V_NMUSUARIO,' '),
             @V_IDTIPOOPER,
             @V_DESC,
             @V_ITPESQ,
             @V_DSSERVERRDM,
             @V_DSREMOTEADDR,
             @V_DSREMOTEHOST,
             @V_DSSERVMETHOD,
             @V_DSREMOTEOPER);
      END;
      FETCH NEXT FROM C_CURSOR_REC   INTO  @V_IDCOMANDO,   @V_CDEMPRESA_NEW, @V_DTREFRECEITABR_NEW,
                                        @V_IDSTATUSMES_NEW, @V_VRRECEITABR_NEW, @V_VRSALDONEGMES_NEW, @V_VRSALDOCOMPOE_NEW,
                                        @V_VRSALDODEDUZ_NEW,@V_CDEMPRESA_OLD,  @V_DTREFRECEITABR_OLD, @V_IDSTATUSMES_OLD,
                                        @V_VRRECEITABR_OLD, @V_VRSALDONEGMES_OLD, @V_VRSALDOCOMPOE_OLD,
                                        @V_VRSALDODEDUZ_OLD;
   END;
   CLOSE C_CURSOR_REC;
   DEALLOCATE C_CURSOR_REC;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_RECEITABRUTA','5.45.xxx';
GO
